2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless
=$
(basename "$0" |
sed -e 's/-/ /')
5 USAGE
="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]
12 or: $dashless [push [--patch] [-k|--[no-]keep-index] [-q|--quiet]
13 [-u|--include-untracked] [-a|--all] [-m <message>]
22 prefix
=$
(git rev-parse
--show-prefix) ||
exit 1
25 TMP
="$GIT_DIR/.git-stash.$$"
26 TMPindex
=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
27 trap 'rm -f "$TMP-"* "$TMPindex"' 0
31 if git config
--get-colorbool color.interactive
; then
32 help_color
="$(git config --get-color color.interactive.help 'red bold')"
33 reset_color
="$(git config --get-color '' reset)"
40 git diff-index
--quiet --cached HEAD
--ignore-submodules -- "$@" &&
41 git diff-files
--quiet --ignore-submodules -- "$@" &&
42 (test -z "$untracked" ||
test -z "$(untracked_files)")
53 excl_opt
=--exclude-standard
54 test "$untracked" = "all" && excl_opt
=
55 git ls-files
-o $z $excl_opt -- "$@"
61 die
"$(gettext "git stash
clear with parameters is unimplemented
")"
63 if current
=$
(git rev-parse
--verify --quiet $ref_stash)
65 git update-ref
-d $ref_stash $current
77 stash_msg
=${1?"BUG: create_stash () -m requires an argument"}
83 stash_msg
=${1#--message=}
85 -u|
--include-untracked)
87 untracked
=${1?"BUG: create_stash () -u requires an argument"}
97 git update-index
-q --refresh
103 # state of the base commit
104 if b_commit
=$
(git rev-parse
--verify HEAD
)
106 head=$
(git rev-list
--oneline -n 1 HEAD
--)
108 die
"$(gettext "You
do not have the initial commit yet
")"
111 if branch
=$
(git symbolic-ref
-q HEAD
)
113 branch
=${branch#refs/heads/}
117 msg
=$
(printf '%s: %s' "$branch" "$head")
120 i_tree
=$
(git write-tree
) &&
121 i_commit
=$
(printf 'index on %s\n' "$msg" |
122 git commit-tree
$i_tree -p $b_commit) ||
123 die
"$(gettext "Cannot save the current index state
")"
125 if test -n "$untracked"
127 # Untracked files are stored by themselves in a parentless commit, for
128 # ease of unpacking later.
130 untracked_files
-z "$@" |
(
131 GIT_INDEX_FILE
="$TMPindex" &&
132 export GIT_INDEX_FILE
&&
134 git update-index
-z --add --remove --stdin &&
135 u_tree
=$
(git write-tree
) &&
136 printf 'untracked files on %s\n' "$msg" | git commit-tree
$u_tree &&
138 ) ) || die
"$(gettext "Cannot save the untracked files
")"
140 untracked_commit_option
="-p $u_commit";
142 untracked_commit_option
=
145 if test -z "$patch_mode"
148 # state of the working tree
150 git read-tree
--index-output="$TMPindex" -m $i_tree &&
151 GIT_INDEX_FILE
="$TMPindex" &&
152 export GIT_INDEX_FILE
&&
153 git diff-index
--name-only -z HEAD
-- "$@" >"$TMP-stagenames" &&
154 git update-index
-z --add --remove --stdin <"$TMP-stagenames" &&
158 die
"$(gettext "Cannot save the current worktree state
")"
162 rm -f "$TMP-index" &&
163 GIT_INDEX_FILE
="$TMP-index" git read-tree HEAD
&&
165 # find out what the user wants
166 GIT_INDEX_FILE
="$TMP-index" \
167 git add--interactive
--patch=stash
-- "$@" &&
169 # state of the working tree
170 w_tree
=$
(GIT_INDEX_FILE
="$TMP-index" git write-tree
) ||
171 die
"$(gettext "Cannot save the current worktree state
")"
173 git diff-tree
-p HEAD
$w_tree -- >"$TMP-patch" &&
174 test -s "$TMP-patch" ||
175 die
"$(gettext "No changes selected
")"
177 rm -f "$TMP-index" ||
178 die
"$(gettext "Cannot remove temporary index
(can
't happen)")"
183 if test -z "$stash_msg"
185 stash_msg=$(printf 'WIP on
%s
' "$msg")
187 stash_msg=$(printf 'On
%s
: %s
' "$branch" "$stash_msg")
189 w_commit=$(printf '%s
\n' "$stash_msg" |
190 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
191 die "$(gettext "Cannot record working tree state")"
206 stash_msg=${1#--message=}
218 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
221 if test -z "$stash_msg"
223 stash_msg="Created via \"git stash store\"."
226 git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit
228 test $ret != 0 && test -z "$quiet" &&
229 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
249 # only default to keep if we don't already have an override
250 test -z "$keep_index" && keep_index
=t
255 -u|
--include-untracked)
263 test -z ${1+x} && usage
270 stash_msg
=${1#--message=}
281 eval_gettextln
"error: unknown option for 'stash push': \$option"
291 eval "set $(git rev-parse --sq --prefix "$prefix" -- "$@
")"
293 if test -n "$patch_mode" && test -n "$untracked"
295 die
"$(gettext "Can
't use --patch and --include-untracked or --all at the same time")"
298 test -n "$untracked" || git ls-files --error-unmatch -- "$@" >/dev/null || exit 1
300 git update-index -q --refresh
303 say "$(gettext "No local changes to save")"
307 git reflog exists $ref_stash ||
308 clear_stash || die "$(gettext "Cannot initialize stash")"
310 create_stash -m "$stash_msg" -u "$untracked" -- "$@"
311 store_stash -m "$stash_msg" -q $w_commit ||
312 die "$(gettext "Cannot save the current status")"
313 say "$(eval_gettext "Saved working directory and index state \$stash_msg")"
315 if test -z "$patch_mode"
317 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
318 if test -n "$untracked"
320 git clean --force --quiet -d $CLEAN_X_OPTION -- "$@"
326 git checkout-index -z --force --stdin
327 git diff-index -p --cached --binary HEAD -- "$@" | git apply --index -R
332 if test "$keep_index" = "t" && test -n "$i_tree"
334 git read-tree --reset $i_tree
335 git ls-files -z --modified -- "$@" |
336 git checkout-index -z --force --stdin
339 git apply -R < "$TMP-patch" ||
340 die "$(gettext "Cannot remove worktree changes")"
342 if test "$keep_index" != "t"
359 # pass all options through to push_stash
360 push_options="$push_options $1"
371 if test -z "$stash_msg"
373 push_stash $push_options
375 push_stash $push_options -m "$stash_msg"
380 git rev-parse --verify --quiet $ref_stash >/dev/null
384 have_stash || return 0
385 git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
389 ALLOW_UNKNOWN_FLAGS=t
390 assert_stash_like "$@"
394 if test "$(git config --bool stash.showStat || echo true)" = "true"
399 if test "$(git config --bool stash.showPatch || echo false)" = "true"
401 FLAGS=${FLAGS}${FLAGS:+ }-p
410 git diff ${FLAGS} $b_commit $w_commit
419 # Parses the remaining options looking for flags and
420 # at most one revision defaulting to ${ref_stash}@{0}
423 # Derives related tree and commit objects from the
424 # revision, if one is found.
426 # stash records the work tree, and is a merge between the
427 # base commit (first parent) and the index tree (second parent).
429 # REV is set to the symbolic version of the specified stash-like commit
430 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
431 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
432 # s is set to the SHA1 of the stash commit
433 # w_commit is set to the commit containing the working tree
434 # b_commit is set to the base commit
435 # i_commit is set to the commit containing the index tree
436 # u_commit is set to the commit containing the untracked files tree
437 # w_tree is set to the working tree
438 # b_tree is set to the base tree
439 # i_tree is set to the index tree
440 # u_tree is set to the untracked files tree
442 # GIT_QUIET is set to t if -q is specified
443 # INDEX_OPTION is set to --index if --index is specified.
444 # FLAGS is set to the remaining flags (if allowed)
447 # * too many revisions specified
448 # * no revision is specified and there is no stash stack
449 # * a revision is specified which cannot be resolve to a SHA1
450 # * a non-existent stash reference is specified
451 # * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
454 parse_flags_and_rev()
456 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
487 test "$ALLOW_UNKNOWN_FLAGS" = t ||
488 die "$(eval_gettext "unknown option: \$opt")"
489 FLAGS="${FLAGS}${FLAGS:+ }$opt"
492 REV="${REV}${REV:+ }'$opt'"
501 have_stash || die "$(gettext "No stash entries found.")"
502 set -- ${ref_stash}@{0}
508 die "$(eval_gettext "Too many revisions specified: \$REV")"
517 set -- "${ref_stash}@{$1}"
521 REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
523 die "$(eval_gettext "\$reference is not a valid reference")"
526 i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
527 set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
535 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
538 u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
539 u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
544 parse_flags_and_rev "$@"
545 test -n "$IS_STASH_LIKE"
548 assert_stash_like() {
549 is_stash_like "$@" || {
551 die "$(eval_gettext "'\
$args' is not a stash-like commit")"
556 is_stash_like "$@" && test -n "$IS_STASH_REF"
560 is_stash_ref "$@" || {
562 die "$(eval_gettext "'\
$args' is not a stash reference")"
568 assert_stash_like "$@"
570 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
572 # current index state
573 c_tree=$(git write-tree) ||
574 die "$(gettext "Cannot apply a stash in the middle of a merge")"
576 unstashed_index_tree=
577 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
578 test "$c_tree" != "$i_tree"
580 git diff-tree --binary $s^2^..$s^2 | git apply --cached
582 die "$(gettext "Conflicts in index. Try without --index.")"
583 unstashed_index_tree=$(git write-tree) ||
584 die "$(gettext "Could not save index tree")"
590 GIT_INDEX_FILE="$TMPindex" git read-tree "$u_tree" &&
591 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
593 die "$(gettext "Could not restore untracked files from stash entry")"
597 GITHEAD_$w_tree='Stashed changes
' &&
598 GITHEAD_$c_tree='Updated upstream
' &&
599 GITHEAD_$b_tree='Version stash was based on
' &&
600 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
603 if test -n "$GIT_QUIET"
605 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
607 if git merge-recursive $b_tree -- $c_tree $w_tree
610 if test -n "$unstashed_index_tree"
612 git read-tree "$unstashed_index_tree"
615 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
616 git read-tree --reset $c_tree &&
617 git update-index --add --stdin <"$a" ||
618 die "$(gettext "Cannot unstage modified files")"
622 if test -n "$GIT_QUIET"
624 squelch='>/dev
/null
2>&1'
626 (cd "$START_DIR" && eval "git status $squelch") || :
628 # Merge conflict; keep the exit status from merge-recursive
631 if test -n "$INDEX_OPTION"
633 gettextln "Index was not unstashed." >&2
640 assert_stash_ref "$@"
647 say "$(gettext "The stash entry is kept in case you need it again.")"
653 assert_stash_ref "$@"
655 git reflog delete --updateref --rewrite "${REV}" &&
656 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
657 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
659 # clear_stash if we just dropped the last stash entry
660 git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
665 test -n "$1" || die "$(gettext "No branch name specified")"
670 assert_stash_like "$@"
672 git checkout -b $branch $REV^ &&
673 apply_stash "$@" && {
674 test -z "$IS_STASH_REF" || drop_stash "$@"
678 test "$1" = "-p" && set "push" "$@"
680 PARSE_CACHE='--not-parsed'
681 # The default command is "push" if nothing but options are given
688 *) seen_non_option=t; break ;;
692 test -n "$seen_non_option" || set "push" "$@"
722 create_stash -m "$*" && echo "$w_commit"
744 say "$(gettext "(To restore them type \"git stash apply\")")"